Unit effr_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure effr(var A :Array of Real; M :Integer; N :Integer;
               var P :Array of Real; var SX :Array of Real;
               var SY :Array of Real; var F :Array of Real; P1 :Real;
               P2 :Real; P3 :Real; var C1 :Array of Real;
               var C2 :Array of Real; var C3 :Array of Real;
               var H :Array of Real);

implementation

procedure effr(var A :Array of Real; M :Integer; N :Integer;
               var P :Array of Real; var SX :Array of Real;
               var SY :Array of Real; var F :Array of Real; P1 :Real;
               P2 :Real; P3 :Real; var C1 :Array of Real;
               var C2 :Array of Real; var C3 :Array of Real;
               var H :Array of Real);
var
I,J,K,L :Integer;
R,R1,R2,R3,R4,S1,S2,S3,S4 :Real;
const
ZERO :Real = 0.0;
HALF :Real = 0.5;
ONE :Real = 1.0;
IDATE :Integer = 170184;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_15;
begin
if ( M <= 2) or (N <= 2 ) 
 then goto _15;
H[41] := (IDATE);
S1 := ZERO;
S2 := ZERO;
I := 1;
J := 1;
K := 2;
R1 := SX[0];
_1:
R2 := SX[K-1];
C3[J-1] := R2-R1;
R := (R2-SX[I-1])*HALF;
_2:
C1[J-1] := R;
J := K;
K := J+1;
I := J-1;
R1 := R2;
if ( J-N ) < 0
 then goto _1
 else if ( J-N ) > 0
       then goto _4
       else goto _3;
_3:
R := C3[I-1]*HALF;
goto _2;
_4:
I := 1;
J := 1;
K := 2;
R1 := SY[0];
H[38] := SY[M-1]-SY[0];
_5:
R := Sqrt(P[J-1]*(SY[K-1]-R1)*HALF);
_6:
F[J-1] := F[J-1]*R;
P[J-1] := R;
R1 := SY[J-1];
S1 := S1+F[J-1]*R;
S2 := S2+F[J-1]*F[J-1];
for L:=1 to N do
 begin
_7:
  A[(J-1)+(L-1)*M] := A[(J-1)+(L-1)*M]*C1[L-1]*R;
 end;
J := K;
K := K+1;
I := K-2;
if ( J-M ) < 0
 then goto _5
 else if ( J-M ) > 0
       then goto _9
       else goto _8;
_8:
R := Sqrt(P[M-1]*(SY[M-1]-R1)*HALF);
goto _6;
_9:
H[36] := S1/H[38];
H[37] := Sqrt(S2-S1*S1/H[38]);
J := 2;
R1 := ONE/C3[0];
R3 := ZERO;
S1 := ZERO;
S3 := ZERO;
_10:
R4 := P3/C1[J-1];
R2 := ONE/C3[J-1];
_11:
S2 := (R1*(R3+R4))*R1+P2*R1;
S4 := R1*R2*R4;
R := S2+S3;
I := J-1;
C1[I-1] := P1*C1[I-1]+R+S1+S3;
C2[I-1] := -R-S4;
C3[I-1] := S4;
S1 := S2;
S3 := S4;
R1 := R2;
R3 := R4;
J := J+1;
if ( J-N ) < 0
 then goto _10
 else if ( J-N ) > 0
       then goto _13
       else goto _12;
_12:
R4 := ZERO;
R2 := ZERO;
goto _11;
_13:
C1[N-1] := P1*C1[N-1]+S2;
C2[N-1] := ZERO;
C3[N-1] := ZERO;
_15:
end;

end.
