Unit efrs_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure efrs(var A :Array of Real; M :Integer; N :Integer;
               var C1 :Array of Real; var C2 :Array of Real;
               var C3 :Array of Real; var H :Array of Real);

implementation

procedure efrs(var A :Array of Real; M :Integer; N :Integer;
               var C1 :Array of Real; var C2 :Array of Real;
               var C3 :Array of Real; var H :Array of Real);
var
I,J :Integer;
R,S1,S2,S3 :Real;
const
ZERO :Real = 0.0;
IDATE :Integer = 60183;
label
_1,_2,_3,_4,_5;
begin
if ( M < N) or (N <= 2 ) 
 then goto _5;
H[42] := (IDATE);
I := 1;
S1 := ZERO;
S2 := ZERO;
S3 := ZERO;
_1:
R := Sqrt(C1[I-1]-S1*S1-S2*S2);
S1 := S3;
S2 := (C2[I-1]-S2*S3)/R;
S3 := C3[I-1]/R;
C1[I-1] := R;
C2[I-1] := S2;
C3[I-1] := S3;
I := I+1;
if ( I-N ) < 0
 then goto _1
 else if ( I-N ) > 0
       then goto _2
       else goto _1;
_2:
S1 := C1[0];
S2 := C1[1];
R := C2[0];
for I:=1 to M do
 begin
  A[(I-1)+0*M] := A[(I-1)+0*M]/S1;
_3:
  A[(I-1)+1*M] := (A[(I-1)+1*M]-A[(I-1)+0*M]*R)/S2;
 end;
for J:=3 to N do
 begin
  S1 := C1[J-1];
  S2 := C2[J-2];
  S3 := C3[J-3];
  for I:=1 to M do
   begin
_4:
    A[(I-1)+(J-1)*M] :=
    (A[(I-1)+(J-1)*M]-A[(I-1)+(J-2)*M]*S2-A[(I-1)+(J-3)*M]*S3)/S1;
   end;
 end;
_5:
end;

end.
