Unit efrd_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure efrd(var U :Array of Real; N :Integer; var C1 :Array of Real;
               var C2 :Array of Real; var C3 :Array of Real;
               var SX :Array of Real; var H :Array of Real);

implementation

procedure efrd(var U :Array of Real; N :Integer; var C1 :Array of Real;
               var C2 :Array of Real; var C3 :Array of Real;
               var SX :Array of Real; var H :Array of Real);
var
J,I :Integer;
R,R1,R2,R3,S1,S2,S3,S4 :Real;
const
HALF :Real = 0.5;
IDATE :Integer = 60183;
label
_1,_2,_3;
begin
if ( N <= 2 ) 
 then goto _3;
H[47] := (IDATE);
I := N-2;
R2 := U[N-1]/C1[N-1];
U[N-1] := R2;
R1 := (U[N-2]-U[N-1]*C2[N-2])/C1[N-2];
U[N-2] := R1;
S1 := EMin1(R1,R2);
S2 := EMax1(R1,R2);
S3 := R2*R2*(SX[N-1]-SX[N-2]);
S3 := HALF*(S3+R1*R1*(SX[N-1]-SX[N-3]));
S4 := Abs(U[N-1]-U[N-2])/(SX[N-1]-SX[N-2]);
_1:
R := (U[I-1]-R1*C2[I-1]-R2*C3[I-1])/C1[I-1];
U[I-1] := R;
if ( R < S1 ) 
 then S1 := R;
if ( R > S2 ) 
 then S2 := R;
J := Max0(I-1,1);
R3 := Abs(U[I+0]-U[I-1])/(SX[I+0]-SX[I-1]);
S3 := S3+R*R*HALF*(SX[I+0]-SX[J-1]);
if ( R3 > S4 ) 
 then S4 := R3;
R2 := R1;
R1 := R;
I := I-1;
if ( I ) < 0
 then goto _2
 else if ( I ) > 0
       then goto _1
       else goto _2;
_2:
H[24] := S1;
H[25] := S2;
H[26] := Sqrt(S3);
H[27] := S4;
_3:
end;

end.
